AMB = {
	NAME = "AdvancedMagicBox",
	VERSION = 0.2,
	AUTHOR = "rv55",
}

-- Function that resizes the magic box according to if it is the transmutor or extractor.
local function ResizeMagicBox()
	if MagicBoxFrame.sw==false then -- Attribute Extractor
		-- Change anchor point for slot 1
		MagicBoxFrameItemButton1:ClearAllAnchors()
		MagicBoxFrameItemButton1:SetAnchor("CENTER","CENTER",MagicBoxFrameItemBackdropFrame)

		-- Reduce frame size
		MagicBoxFrame:SetWidth(250)
		MagicBoxFrameItemBackdropFrame:SetWidth(200)
		UIPanelBackdropFrame_SetTexture( MagicBoxFrame, "Interface/Common/PanelCommonFrame", 256 , 256 );
	else -- Arcane Transmutor
		-- Change anchor point for slot 1
		MagicBoxFrameItemButton1:ClearAllAnchors()
		MagicBoxFrameItemButton1:SetAnchor("LEFT","LEFT",MagicBoxFrameItemBackdropFrame,70,0)

		-- Increase frame size
		MagicBoxFrame:SetWidth(400)
		MagicBoxFrameItemBackdropFrame:SetWidth(350)
		UIPanelBackdropFrame_SetTexture( MagicBoxFrame, "Interface/Common/PanelCommonFrame", 256 , 256 );
	end
end

-- Function that checks if there are items in the "hidden" slots.
local function HiddenSlotsAreNotEmpty()
	for i = 56, 60 do
		local __, name = GetGoodsItemInfo(i)
		if name ~= "" then
			return true -- Not empty
		end
	end

	return false
end

function AMB_OnLoad()
	-- Set number of slots to 10
	DF_MagicBoxItemButton_Max = 10

	-- Add AMB version string
	MagicBoxFrameAMBString:SetText("|cffaaaaaa"..AMB.NAME.." v"..AMB.VERSION.." by "..AMB.AUTHOR.."|r")

	-- Hook into the frame update function to resize frame
	if not AMB_MagicBoxFrame_Update then
		AMB_MagicBoxFrame_Update = MagicBoxFrame_Update
	end
	function MagicBoxFrame_Update(frame)
		-- Call original function
		AMB_MagicBoxFrame_Update(frame)

		-- Do AMB resizing of MagicBoxFrame
		ResizeMagicBox()
	end

	-- Hook into the Transmutor Preview Result function to disable the preview and "Confirm" button
	if not AMB_GetMagicBoxPreviewResult then
		AMB_GetMagicBoxPreviewResult = GetMagicBoxPreviewResult
	end
	function GetMagicBoxPreviewResult()
		-- Check if hidden slots are empty
		if HiddenSlotsAreNotEmpty() then
			return nil -- Not empty
		end

		-- Else return original function
		return AMB_GetMagicBoxPreviewResult()
	end

	-- Hook into the Extractor Can Draw function to disable the "Confirm" button
	if not AMB_MagicBoxCanDrawStone then
		AMB_MagicBoxCanDrawStone = MagicBoxCanDrawStone
	end
	function MagicBoxCanDrawStone()
		-- Check if hidden slots are empty
		if HiddenSlotsAreNotEmpty() then
			return false -- Not empty
		end

		-- Else return original function
		return AMB_MagicBoxCanDrawStone()
	end
end

