
aai = {
	Addonname       = "AutoAcceptInvitations",
	Version         = "0.4",
	Countdown       = 0,
	Countdown2      = 0,
	action          = "leave",
	action2         = "",
	player          = "",
	warn5			= 1,
	active			= 0,
	welcome         = 0,
	gone			= 0,
	autoenabled     = 0,
	reinvite        = 0,
};

aai.DefaultSettings = {
	AutoLeave 		  = 1,
	Minutes			  = 60,
	Invite		  	  = 1,
	Promote           = 1,
	autoenableminutes = 30
}
aai.DefaultCharSettings = {
	active          = 0,
	autoenable      = 1,
}

function aai_OnLoad(frame)
	frame:RegisterEvent("PARTY_INVITE_REQUEST");
	frame:RegisterEvent("PARTY_MEMBER_CHANGED");
	frame:RegisterEvent("VARIABLES_LOADED");
    frame:RegisterEvent("CHAT_MSG_GUILD");

	SaveVariables("AAI_Settings");
	SaveVariablesPerCharacter("AAI_Char_Settings");

	local Sol = LibStub("Sol");
end;


function aai_saveconfig()
	local Minutes = tonumber(aaiConfig_minutes:GetText());
	if (Minutes <= 0) then
		Minutes = 60;
	end;
	if (Minutes > 300) then
		Minutes = 300;
	end;

	local aMinutes = tonumber(aaiConfig_autoenableminutes:GetText());
	if (aMinutes <= 5) then
		aMinutes = 5;
	end;
	if (aMinutes > 60) then
		aMinutes = 60;
	end;

	if (aaiConfig_autoleave:IsChecked()) then
		local groupsize = GetNumPartyMembers();
		if (groupsize == nil) then groupsize = 0; end;
		if (AAI_Settings.AutoLeave == 0) and (groupsize > 1) then
			aai.Countdown = (Minutes * 60);
			CooldownFrame_SetTime(aai_Minimap_SwitchCooldown,Minutes * 60,Minutes * 60);
			aai.action = "leave";
		end;
		AAI_Settings.AutoLeave = 1;
		if (aai.Countdown > (Minutes * 60)) and (aai.action == "leave") then
			aai.Countdown = (Minutes * 60);
			CooldownFrame_SetTime(aai_Minimap_SwitchCooldown,Minutes * 60,Minutes * 60);
		end;
	else
		AAI_Settings.AutoLeave = 0;
		aai.Countdown = 0;
		CooldownFrame_SetTime(aai_Minimap_SwitchCooldown,1,1);
	end;

	if (aaiConfig_autoenable:IsChecked()) then
		AAI_Char_Settings.autoenable = 1;
	else
		AAI_Char_Settings.autoenable = 0;
	end;

	AAI_Settings.Minutes = Minutes;
	AAI_Settings.autoenableminutes = aMinutes;

	if (aaiConfig_autoinvite:IsChecked()) then
		AAI_Settings.Invite = 1;
	else
		AAI_Settings.Invite = 0;
	end;

	if (aaiConfig_promote:IsChecked()) then
		AAI_Settings.Promote = 1;
	else
		AAI_Settings.Promote = 0;
	end;
end;


function aai_OnEvent(event, this)

	local n;

	if (event == "VARIABLES_LOADED") then
		if not(AAI_Settings) then
		  AAI_Settings = aai.DefaultSettings;
		  aaiConfig:Show();
		end;
		if not(AAI_Char_Settings) then
		  AAI_Char_Settings = aai.DefaultCharSettings;
		end;
		aaiConfig_autoleave:SetChecked(AAI_Settings.AutoLeave == 1);
		aaiConfig_minutes:SetText(AAI_Settings.Minutes);
		aaiConfig_autoinvite:SetChecked(AAI_Settings.Invite == 1);
		aaiConfig_promote:SetChecked(AAI_Settings.Promote == 1);
		aaiConfig_autoenable:SetChecked(AAI_Char_Settings.autoenable == 1);
		aaiConfig_autoenableminutes:SetText(AAI_Settings.autoenableminutes);

		aai.translate();

		if (AAI_Char_Settings.active == 1) and (aai.active == 0) then
			aai.toggle();
		end;
		Sol.hooks.Hook("aai", "CRF_TalkFrame_AddMessage", aai_AddMessage);

		if AddonManager then
			local addon = {
				name = aai.Addonname,
				version = aai.Version,
				author = "Arne",
				description = aai.Strings.description,
				icon = "Interface/Addons/AutoAcceptInvitations/Textures/config32.tga",
				category = "Social",
				configFrame = aaiConfig,
				slashCommands = "/aai",
				miniButton = aaiMiniButton,
				disableScript = aai.turnoff,
				enableScript = aai.turnon,
			}
			if AddonManager.RegisterAddonTable then
				AddonManager.RegisterAddonTable(addon)
			else
				AddonManager.RegisterAddon(addon.name, addon.description, addon.icon, addon.category,
					addon.configFrame, addon.slashCommand, addon.miniButton, addon.version, addon.author)
			end;
		end;

		if (MinimapFrameBulletinButton:IsVisible()) then
			MinimapFrameBulletinButton:Hide();
		end;

		SLASH_AAI1 = "/aai";
		SlashCmdList["AAI"] = aai.slash;

		aai_Minimap_SwitchCooldownText:SetFontSize(11);

		aai_io(string.format(aai.Addonname.." "..aai.Strings.slash,"/aai"));
	end;


	if (event == "CHAT_MSG_GUILD") then
		if (aai.active == 1) then
			if (string.find(arg1,"^farm$") ~= nil) then
				if (arg4 ~= UnitName("player")) then
					local groupsize = GetNumPartyMembers();
					if (groupsize == 0) and (aai.action ~= "invite") then
						aai.player = arg4;
						aai.welcome = 1;
						InviteByName(aai.player);
					end;
				end;
			end;
		end;
	end;


	if (event == "PARTY_MEMBER_CHANGED") then
		if (arg1 ~= nil) then
			local groupsize = GetNumPartyMembers();
			if groupsize == 0 then
				if (AAI_Settings.Invite == 1) and (aai.active == 1) and (aai.player ~= "") then
					aai.action = "invite";
					aai.Countdown = 20;
					CooldownFrame_SetTime(aai_Minimap_SwitchCooldown,20,20);
					aai_io(string.format(aai.Strings.willInvite, aai.player));
				else
					if (AAI_Settings.Promote == 1) and (aai.active == 1) then
						aai.action = "wait";
						aai.Countdown = 120;
						CooldownFrame_SetTime(aai_Minimap_SwitchCooldown,120,120);
					end;
				end;
			else

				if (aai.active == 1) then
					for n=1,4 do
						if getglobal("StaticPopup"..n):IsVisible()
						and string.find(getglobal("StaticPopup"..n.."Text"):GetText(),CHANGE_LEADER_CHANNEL)~=nil then
							getglobal("StaticPopup"..n):Hide();
						end;
					end;
				end;

				if IsPartyLeader() and (aai.active == 1) then
					SetInstanceLevel("normal");
					aai.action = "";
					aai.action2 = "promote";
					aai.Countdown2 = 2;

					if (aai.welcome == 1) then
						aai.welcome = 0;
						if (AAI_Settings.AutoLeave == 1) then
							SendChatMessage("|H|h|cff00ff00[AutoAcceptInvitations]|h "..string.format(aai.Strings.welcome, aai.player).." "..string.format(aai.Strings.inform, AAI_Settings.Minutes),"WHISPER",0,aai.player);
						else
							SendChatMessage("|H|h|cff00ff00[AutoAcceptInvitations]|h "..string.format(aai.Strings.welcome, aai.player).." "..aai.Strings.pleaseGo,"WHISPER",0,aai.player);
						end;
					end;

				end;
			end;
		else
			local groupsize = GetNumPartyMembers();
			if (groupsize == nil) then
				groupsize = -1;
			end;
			if (groupsize > 1) then

				if (aai.active == 1) then
					for n=1,4 do
						if getglobal("StaticPopup"..n):IsVisible()
						and string.find(getglobal("StaticPopup"..n.."Text"):GetText(),CHANGE_LEADER_CHANNEL)~=nil then
							getglobal("StaticPopup"..n):Hide();
						end;
					end;
				end;

				if IsPartyLeader() and (aai.active == 1) then
					SetInstanceLevel("normal");
					aai.action = "";
					aai.action2 = "promote";
					aai.Countdown2 = 2;

					if (aai.welcome == 1) then
						aai.welcome = 0;
						if (AAI_Settings.AutoLeave == 1) then
							SendChatMessage("|H|h|cff00ff00[AutoAcceptInvitations]|h "..string.format(aai.Strings.welcome, aai.player).." "..string.format(aai.Strings.inform, AAI_Settings.Minutes),"WHISPER",0,aai.player);
						else
							SendChatMessage("|H|h|cff00ff00[AutoAcceptInvitations]|h "..string.format(aai.Strings.welcome, aai.player).." "..aai.Strings.pleaseGo,"WHISPER",0,aai.player);
						end;
					end;

				end;
			end;
		end;
	end;


	if (event == "PARTY_INVITE_REQUEST") and (aai.active == 1) then
		-- arg1 = Name of inviting User

		aai.player = arg1;
		aai.welcome = 0;

		for n=1,4 do
			if getglobal("StaticPopup"..n):IsVisible()
			and string.find(getglobal("StaticPopup"..n.."Text"):GetText(),string.gsub(ASK_INVITE_TO_PARTY,"%%s",arg1))~=nil then
				getglobal("StaticPopup"..n):Hide();
			end;
		end;


		AcceptGroup();
		if (AAI_Settings.AutoLeave == 1) then
			aai.action = "leave";
			aai.setCountdown();
			SendChatMessage("|H|h|cff00ff00[AutoAcceptInvitations]|h "..string.format(aai.Strings.welcome, arg1).." "..string.format(aai.Strings.inform, AAI_Settings.Minutes),"WHISPER",0,arg1);
		else
			aai.action = "leave";
			aai.Countdown = 0;
			CooldownFrame_SetTime(aai_Minimap_SwitchCooldown,1,1);
			SendChatMessage("|H|h|cff00ff00[AutoAcceptInvitations]|h "..string.format(aai.Strings.welcome, arg1).." "..aai.Strings.pleaseGo,"WHISPER",0,arg1);
		end;

	end;
end;


function aai.setCountdown()
	aai.Countdown = AAI_Settings.Minutes * 60;
	CooldownFrame_SetTime(aai_Minimap_SwitchCooldown,AAI_Settings.Minutes * 60,AAI_Settings.Minutes * 60);
	if (AAI_Settings.Minutes > 5) then
		aai.warn5 = 0;
	else
		aai.warn5 = 1;
	end;
end;


function aai_io(msg,c1,c2,c3)
	DEFAULT_CHAT_FRAME:AddMessage("[|cff00ff00".."AAI|r] "..msg,c1,c2,c3);
end;


function aai.MinimapButton_OnEnter(this)
	GameTooltip:SetOwner(this, "ANCHOR_LEFT", 4, 0);
	GameTooltip:SetText("AutoAcceptInvitations v"..aai.Version, 1, 1, 1);
	GameTooltip:AddLine(aai.Strings.MinimapLeft, 0, 0.75, 0.95);
	GameTooltip:AddLine(aai.Strings.MinimapRight, 0, 0.75, 0.95);
	GameTooltip:AddLine(UI_MINIMAPBUTTON_MOVE, 0, 0.75, 0.95);
	GameTooltip:Show();
end;


function aai.MinimapButton_onClick(this, key)
	if key == "LBUTTON" then
		if aaiConfig:IsVisible() == false then
			aaiConfig:Show();
		end;
	elseif key == "RBUTTON" and not IsShiftKeyDown() then
		aai.toggle();
	end;
end;


function aai.slash(_, msg)
	if (msg == "on") then
		if (aai.active == 0) then
			aai.toggle();
		else
			aai_io(aai.Strings.activated);
		end;
	elseif (msg == "off") then
		if (aai.active == 0) then
			aai_io(aai.Strings.inactive);
		else
			aai.toggle();
		end;
	elseif (msg == "toggle") then
		aai.toggle();
	elseif (msg == "config") then
		if aaiConfig:IsVisible() == false then
			aaiConfig:Show();
		end
	else
		aai_io("/aai on: "..aai.Strings.on);
		aai_io("/aai off: "..aai.Strings.off);
		aai_io("/aai toggle: "..aai.Strings.toggle);
		aai_io("/aai config: "..aai.Strings.config);
		aai_io("/aai help: "..aai.Strings.help);
	end;
end;


function aai.toggle()
	if (aai.active == 0) then
		aai.active = 1;
		aai_MiniMapFlash:SetColor(0, 1, 0);
		local message = aai.Strings.activated;

		local groupsize = GetNumPartyMembers();

		if (groupsize > 1) then
			if (AAI_Settings.AutoLeave == 1) then
				aai.action = "leave";
				aai.setCountdown();
				aai.player = "";
				message = message.." "..aai.Strings.existingGroup;
			end;
		else
			if (AAI_Settings.Promote == 1) then
				aai.action = "wait";
				aai.Countdown = 120;
				CooldownFrame_SetTime(aai_Minimap_SwitchCooldown,120,120);
				message = message.." "..aai.Strings.willPromote;
			end;
		end;

		if (AAI_Char_Settings.active == 0) then
			aai_io(message);
			SendSystemMsg(message);
		end;

		AAI_Char_Settings.active = 1;
	else
		aai.active = 0;
		AAI_Char_Settings.active = 0;
		aai_MiniMapFlash:SetColor(1, 0, 0);
		SendSystemMsg(aai.Strings.inactive);
		aai_io(aai.Strings.inactive);
		aai.Countdown = 0;
		CooldownFrame_SetTime(aai_Minimap_SwitchCooldown,1,1);
		aai.action = "leave";
	end;
end;


function aai.turnon()
	if (aai.active == 0) then
		aai.toggle();
	end;
end;


function aai.turnoff()
	if (aai.active == 1) then
		aai.toggle();
	end;
end;


function aai_AddMessage(MsnWin,who,msg)
  local i;
  if (string.find(msg,"%[AutoAcceptInvitations%]")~=nil) and (who == UnitName("player")) then
    getglobal(MsnWin:GetName()):Hide();
  else
    Sol.hooks.GetOriginalFn("aai", "CRF_TalkFrame_AddMessage")(MsnWin,who,msg);
  end;
end;


aai_ChatFrame_OnEvent = ChatFrame_OnEvent;

function ChatFrame_OnEvent(this, event)
	local i;
	if (string.sub(event, 1, 8) == "CHAT_MSG") then
		local type = string.sub(event, 10);
		local chatflag = false;
		if (type == "WHISPER_INFORM") then
			if (string.find(arg1,"%[AutoAcceptInvitations%]")~=nil) then
				chatflag = true;
			end;
			if (not chatflag) then
				aai_ChatFrame_OnEvent(this, event);
			end;
		else
			aai_ChatFrame_OnEvent(this, event);
		end;
	else
		aai_ChatFrame_OnEvent(this, event);
	end;
end;


function aai.translate()
	aai.Language = string.upper(string.sub(GetLanguage(),1,2));

	local  func, err = loadfile("Interface/Addons/AutoAcceptInvitations/Locales/"..aai.Language..".lua");
	if (err) then
		aai.Language = "EN";
	end;

	dofile("Interface/Addons/AutoAcceptInvitations/Locales/"..aai.Language..".lua");

	aaiConfigTitleFrame_Title:SetText("AutoAcceptInvitations v"..aai.Version);
	aaiConfigBackdropFrame_autoleavetext:SetText(aai.Strings.autoleave);
	aaiConfigBackdropFrame_minutestext:SetText(aai.Strings.minutes);
	aaiConfigBackdropFrame_autoinvitetext:SetText(aai.Strings.autoinvite);
	aaiConfigBackdropFrame_promotetext:SetText(aai.Strings.promote);
	aaiConfigBackdropFrame_autoenabletext:SetText(aai.Strings.autoenable);
	aaiConfigBackdropFrame_autoenableminutestext:SetText(aai.Strings.autoenablemin);
end;


function aai_OnUpdate(frame, elapsedTime)

	-- Inactivity
	if (AAI_Char_Settings.autoenable == 1) then
		aai.gone = aai.gone + elapsedTime;
	end;

	if (aai.gone > (AAI_Settings.autoenableminutes * 60)) then
		if (aai.autoenabled == 0) then
			if (aai.active == 0) then
				aai.autoenabled = 1;
				aai.toggle();
			end;
		end;
	end;


	-- normal Counters
	if (aai.Countdown > 0) then
		aai.Countdown = aai.Countdown - elapsedTime;
		if (aai.Countdown <= 0) then

			if (aai.action == "wait") then
				SendChatMessage(aai.Strings.ready.." "..string.format(aai.Strings.usage,"farm"),"GUILD");
				aai_io(aai.Strings.ready.." "..string.format(aai.Strings.usage,"farm"));
			elseif (aai.action == "invite") then
				if (aai.player ~= "")  then
					InviteByName(aai.player);
					if (AAI_Settings.Promote == 1) then
						aai.action = "wait";
						aai.Countdown = 120;
						CooldownFrame_SetTime(aai_Minimap_SwitchCooldown,120,120);
					end;
				end;
			elseif (aai.action == "leave") or (aai.action == "") then
				if (AAI_Settings.AutoLeave == 1) then
					LeaveParty();
				end;
			--[[elseif (aai.action == "promote") then
				PromoteToPartyLeader("party1");
				aai.action = "leave";
				aai.action2 = "promotecheck";
				aai.Countdown2 = 2;
				if (AAI_Settings.AutoLeave == 1) then
					if (aai.Countdown > 0) then
						CooldownFrame_SetTime(aai_Minimap_SwitchCooldown,aai.CountDown,AAI_Settings.Minutes * 60);
					else
						aai.setCountdown();
					end;
				end;]]
			end;
		end;
		if (aai.action == "leave") and (aai.Countdown <= 300) and (aai.warn5 == 0) then
			aai.warn5 = 1;
			if (aai.player ~= "") then
				SendChatMessage("|H|h|cff00ff00[AutoAcceptInvitations]|h "..aai.Strings.willLeaveSoon,"WHISPER",0,aai.player);
			end;
		end;
	end;

	if (aai.Countdown2 > 0) then
		aai.Countdown2 = aai.Countdown2 - elapsedTime;
		if (aai.Countdown2 <= 0) then
			if (aai.action2 == "promote") then
				PromoteToPartyLeader("party1");
				aai.action = "leave";
				aai.action2 = "promotecheck";
				aai.Countdown2 = 2;
				if (AAI_Settings.AutoLeave == 1) then
					if ((aai.Countdown > 0) and (aai.reinvite == 1)) then
						CooldownFrame_SetTime(aai_Minimap_SwitchCooldown,AAI_Settings.Minutes * 60,aai.Countdown);
					else
						aai.setCountdown();
					end;
				end;
				aai.reinvite = 0;
			elseif (aai.action2 == "leave") then
				aai.action2 = "";
				aai.player = "";
				aai.reinvite = 0;
				LeaveParty();
			elseif (aai.action2 == "promotecheck") then
				if (IsPartyLeader()) then
					aai_io(aai.Strings.elvis);
					aai.Countdown2 = 180;
					CooldownFrame_SetTime(aai_Minimap_SwitchCooldown,180,180);
					aai.action2 = "leave";
					aai.reinvite = 1;
				else
					if (AAI_Settings.AutoLeave == 0) then
						CooldownFrame_SetTime(aai_Minimap_SwitchCooldown,1,1);
					end;
					aai.action2 = "";
				end;
			end;
		end;
	end;
end;

function aai.actionperformed()
	aai.gone = 0;
	if (aai.autoenabled == 1) then
		aai.autoenabled = 0;
		aai.toggle();
	end;
end;


function aaiConfig_onLoad(frame)

end;
